Index: /branches/network/src/util/loading/resource_manager.cc
===================================================================
--- /branches/network/src/util/loading/resource_manager.cc	(revision 6692)
+++ /branches/network/src/util/loading/resource_manager.cc	(revision 6693)
@@ -18,7 +18,9 @@
 #include "resource_manager.h"
 
+#include "substring.h"
 #include "debug.h"
 
 #include <algorithm>
+#include <assert.h>
 
 // different resource Types
@@ -50,5 +52,5 @@
 
 /**
- *  standard constructor
+ * @brief standard constructor
 */
 ResourceManager::ResourceManager ()
@@ -66,5 +68,5 @@
 
 /**
- *  standard destructor
+ * @brief standard destructor
 */
 ResourceManager::~ResourceManager ()
@@ -78,8 +80,8 @@
   // deleting the Directorie Lists
   while (!this->imageDirs.empty())
-    {
-      delete[] this->imageDirs.front();
-      this->imageDirs.pop_front();
-    }
+  {
+    delete[] this->imageDirs.back();
+    this->imageDirs.pop_back();
+  }
 
   delete[] this->dataDir;
@@ -89,5 +91,5 @@
 
 /**
- *  sets the data main directory
+ * @brief sets the data main directory
  * @param dataDir the DataDirectory.
  */
@@ -122,5 +124,5 @@
 
 /**
- * sets the data main directory
+ * @brief sets the data main directory
  * @param dataDir the DataDirectory.
  *
@@ -153,7 +155,6 @@
 
 
-
-/**
- * checks for the DataDirectory, by looking if
+/**
+ * @brief checks for the DataDirectory, by looking if
  * @param fileInside is iniside of the given directory.
 */
@@ -162,8 +163,8 @@
   bool retVal;
   if (!isDir(this->dataDir))
-    {
-      PRINTF(1)("%s is not a directory\n", this->dataDir);
-      return false;
-    }
+  {
+    PRINTF(1)("%s is not a directory\n", this->dataDir);
+    return false;
+  }
 
   char* testFile = new char[strlen(this->dataDir)+strlen(fileInside)+1];
@@ -176,5 +177,5 @@
 #ifndef NO_TEXTURES
 /**
- *  adds a new Path for Images
+ * @brief adds a new Path for Images
  * @param imageDir The path to insert
  * @returns true, if the Path was well and injected (or already existent within the list)
@@ -201,39 +202,40 @@
   // check if the param is a Directory
   if (isDir(newDir))
-    {
-      // check if the Directory has been added before
-      std::list<char*>::const_iterator imageDir;
-      for (imageDir = this->imageDirs.begin(); imageDir != this->imageDirs.end(); imageDir++)
+  {
+    // check if the Directory has been added before
+    std::vector<char*>::const_iterator imageDir;
+    for (imageDir = this->imageDirs.begin(); imageDir != this->imageDirs.end(); imageDir++)
+    {
+      if (!strcmp(*imageDir, newDir))
       {
-         if (!strcmp(*imageDir, newDir))
-         {
-           PRINTF(3)("Path %s already loaded\n", newDir);
-           delete[] newDir;
-           return true;
-         }
+        PRINTF(3)("Path %s already loaded\n", newDir);
+        delete[] newDir;
+        return true;
       }
-      // adding the directory to the List
-      this->imageDirs.push_back(newDir);
-      return true;
-    }
-  else
-    {
-      PRINTF(1)("%s is not a Directory, and can not be added to the Paths of Images\n", newDir);
-      delete[] newDir;
-      return false;
-    }
+    }
+    // adding the directory to the List
+    this->imageDirs.push_back(newDir);
+    return true;
+  }
+  else
+  {
+    PRINTF(1)("%s is not a Directory, and can not be added to the Paths of Images\n", newDir);
+    delete[] newDir;
+    return false;
+  }
 }
 #endif /* NO_TEXTURES */
 
 /**
- *  loads resources
+ * @brief loads resources
  * @param fileName: The fileName of the resource to load
  * @param prio: The ResourcePriority of this resource (will only be increased)
+ * @param param0: an additional option to parse (see the constuctors for more help)
  * @param param1: an additional option to parse (see the constuctors for more help)
  * @param param2: an additional option to parse (see the constuctors for more help)
- * @param param3: an additional option to parse (see the constuctors for more help)
  * @returns a pointer to a desired Resource.
 */
-BaseObject* ResourceManager::load(const char* fileName, ResourcePriority prio, void* param1, void* param2, void* param3)
+BaseObject* ResourceManager::load(const char* fileName, ResourcePriority prio,
+                                  const MultiType& param0, const MultiType& param1, const MultiType& param2)
 {
   if (fileName == NULL)
@@ -258,233 +260,306 @@
 #endif
 #define __IF_OK
-  if (!strncasecmp(fileName+(strlen(fileName)-4), ".wav", 4))
-    tmpType = WAV;
-  else if (!strncasecmp(fileName+(strlen(fileName)-4), ".mp3", 4))
-    tmpType = MP3;
-  else if (!strncasecmp(fileName+(strlen(fileName)-4), ".ogg", 4))
-    tmpType = OGG;
+    if (!strncasecmp(fileName+(strlen(fileName)-4), ".wav", 4))
+      tmpType = WAV;
+    else if (!strncasecmp(fileName+(strlen(fileName)-4), ".mp3", 4))
+      tmpType = MP3;
+    else if (!strncasecmp(fileName+(strlen(fileName)-4), ".ogg", 4))
+      tmpType = OGG;
 #endif /* NO_AUDIO */
 #ifndef NO_TEXT
 #ifdef __IF_OK
-  else
+    else
 #endif
 #define __IF_OK
- if (!strncasecmp(fileName+(strlen(fileName)-4), ".ttf", 4))
-    tmpType = TTF;
+      if (!strncasecmp(fileName+(strlen(fileName)-4), ".ttf", 4))
+        tmpType = TTF;
 #endif /* NO_TEXT */
 #ifndef NO_SHADERS
 #ifdef __IF_OK
-  else
+      else
 #endif
 #define __IF_OK
- if (!strncasecmp(fileName+(strlen(fileName)-5), ".vert", 5))
-    tmpType = SHADER;
+        if (!strncasecmp(fileName+(strlen(fileName)-5), ".vert", 5))
+          tmpType = SHADER;
 #endif /* NO_SHADERS */
 #ifndef NO_TEXTURES
 #ifdef __IF_OK
-  else
+        else
 #else
   if
 #endif
-   tmpType = IMAGE;
+          tmpType = IMAGE;
 #endif /* NO_TEXTURES */
 #undef __IF_OK
-  return this->load(fileName, tmpType, prio, param1, param2, param3);
-}
-
-/**
- * loads resources
+  return this->load(fileName, tmpType, prio, param0, param1, param2);
+}
+
+/**
+ * @brief caches a Resource
+ *
+ * @see load;
+ *
+ * @brief returns true if ok, false otherwise.
+ * This function loads a Resource without applying it to an Object.
+ * This is for loading purposes, e.g, when the user is loading a Resource
+ * during the initialisation instead of at Runtime.
+ */
+bool ResourceManager::cache(const char* fileName, ResourceType type, ResourcePriority prio,
+                            const MultiType& param0, const MultiType& param1, const MultiType& param2)
+{
+  assert(fileName != NULL);
+
+  // searching if the resource was loaded before.
+  Resource* tmpResource;
+  // check if we already loaded this Resource
+  tmpResource = this->locateResourceByInfo(fileName, type, param0, param1, param2);
+  // otherwise load it
+  if (tmpResource == NULL)
+    tmpResource = this->loadResource(fileName, type, prio, param0, param1, param2);
+  // return cached pointer.
+  if (tmpResource != NULL) // if the resource was loaded before.
+  {
+    if(tmpResource->prio < prio)
+      tmpResource->prio = prio;
+    return true;
+  }
+  else
+    return false;
+}
+
+/**
+ * tells the ResourceManager to generate a Copy of the Resource.
+ * @brief resourcePointer: The Pointer to the resource to copy
+ * @returns the Resource pointed to resourcePointer.
+ */
+BaseObject* ResourceManager::copy(BaseObject* resourcePointer)
+{
+  Resource* tmp = locateResourceByPointer(resourcePointer);
+  if (tmp!=NULL)
+  {
+    tmp->count++;
+    return tmp->pointer;
+  }
+  else
+    return NULL;
+}
+
+
+/**
+ * @brief loads resources
  * @param fileName: The fileName of the resource to load
  * @param type: The Type of Resource to load.
  * @param prio: The ResourcePriority of this resource (will only be increased)
+ * @param param0: an additional option to parse (see the constuctors for more help)
  * @param param1: an additional option to parse (see the constuctors for more help)
  * @param param2: an additional option to parse (see the constuctors for more help)
- * @param param3: an additional option to parse (see the constuctors for more help)
  * @returns a pointer to a desired Resource.
 */
 BaseObject* ResourceManager::load(const char* fileName, ResourceType type, ResourcePriority prio,
-                            void* param1, void* param2, void* param3)
-{
-  if (fileName == NULL)
+                                  const MultiType& param0, const MultiType& param1, const MultiType& param2)
+{
+  assert(fileName != NULL);
+
+  // searching if the resource was loaded before.
+  Resource* tmpResource;
+  // check if we already loaded this Resource
+  tmpResource = this->locateResourceByInfo(fileName, type, param0, param1, param2);
+  // otherwise load it
+  if (tmpResource == NULL)
+  {
+    tmpResource = this->loadResource(fileName, type, prio, param0, param1, param2);
+  }
+  // return cached pointer.
+  if (tmpResource != NULL) // if the resource was loaded before.
+  {
+    tmpResource->count++;
+    if(tmpResource->prio < prio)
+      tmpResource->prio = prio;
+
+    return tmpResource->pointer;
+  }
+  else
     return NULL;
-
-  // searching if the resource was loaded before.
-  Resource* tmpResource = this->locateResourceByInfo(fileName, type, param1, param2, param3);
-  if (tmpResource != NULL) // if the resource was loaded before.
-    {
-      PRINTF(4)("not loading cached resource %s\n", tmpResource->name);
-      tmpResource->count++;
-      if(tmpResource->prio < prio)
-        tmpResource->prio = prio;
-    }
-  else
-    {
-      // Setting up the new Resource
-      tmpResource = new Resource;
-      tmpResource->count = 1;
-      tmpResource->type = type;
-      tmpResource->prio = prio;
-      tmpResource->pointer = NULL;
-      tmpResource->name = new char[strlen(fileName)+1];
-      strcpy(tmpResource->name, fileName);
-
-      // creating the full name. (directoryName + FileName)
-      char* fullName = ResourceManager::getFullName(fileName);
-      // Checking for the type of resource \see ResourceType
-      switch(type)
-        {
+}
+
+
+/**
+ * @brief loads resources for internal purposes
+ * @param fileName: The fileName of the resource to load
+ * @param type: The Type of Resource to load.
+ * @param prio: The ResourcePriority of this resource (will only be increased)
+ * @param param0: an additional option to parse (see the constuctors for more help)
+ * @param param1: an additional option to parse (see the constuctors for more help)
+ * @param param2: an additional option to parse (see the constuctors for more help)
+ * @returns a pointer to a desired Resource.
+ */
+Resource* ResourceManager::loadResource(const char* fileName, ResourceType type, ResourcePriority prio,
+                                        const MultiType& param0, const MultiType& param1, const MultiType& param2)
+{
+  // Setting up the new Resource
+  Resource* tmpResource = new Resource;
+  tmpResource->count = 0;
+  tmpResource->type = type;
+  tmpResource->prio = prio;
+  tmpResource->pointer = NULL;
+  tmpResource->name = new char[strlen(fileName)+1];
+  strcpy(tmpResource->name, fileName);
+
+  // creating the full name. (directoryName + FileName)
+  char* fullName = ResourceManager::getFullName(fileName);
+  // Checking for the type of resource \see ResourceType
+  switch(type)
+  {
 #ifndef NO_MODEL
-        case OBJ:
-          if (param1)
-            tmpResource->modelSize = *(float*)param1;
-          else
-            tmpResource->modelSize = 1.0;
-
-          if(ResourceManager::isFile(fullName))
-            tmpResource->pointer = new OBJModel(fullName, tmpResource->modelSize);
-          else
-            {
-              PRINTF(2)("File %s in %s does not exist. Loading a cube-Model instead\n", fileName, dataDir);
-              tmpResource->pointer = ResourceManager::load("cube", PRIM, prio, &tmpResource->modelSize);
-            }
-          break;
-        case PRIM:
-          if (param1)
-            tmpResource->modelSize = *(float*)param1;
-          else
-            tmpResource->modelSize = 1.0;
-
-          if (!strcmp(tmpResource->name, "cube"))
-            tmpResource->pointer = new PrimitiveModel(PRIM_CUBE, tmpResource->modelSize);
-          else if (!strcmp(tmpResource->name, "sphere"))
-            tmpResource->pointer = new PrimitiveModel(PRIM_SPHERE, tmpResource->modelSize);
-          else if (!strcmp(tmpResource->name, "plane"))
-            tmpResource->pointer = new PrimitiveModel(PRIM_PLANE, tmpResource->modelSize);
-          else if (!strcmp(tmpResource->name, "cylinder"))
-            tmpResource->pointer = new PrimitiveModel(PRIM_CYLINDER, tmpResource->modelSize);
-          else if (!strcmp(tmpResource->name, "cone"))
-            tmpResource->pointer = new PrimitiveModel(PRIM_CONE, tmpResource->modelSize);
-          break;
-        case MD2:
-          if(ResourceManager::isFile(fullName))
-            {
-              if (param1 != NULL)
-                {
-                  tmpResource->secFileName = new char[strlen((const char*)param1)+1];
-                  strcpy(tmpResource->secFileName, (const char*) param1);
-                }
-              else
-                tmpResource->secFileName = NULL;
-                tmpResource->pointer = new MD2Data(fullName, tmpResource->secFileName);
-//               tmpResource->pointer = new MD2Model(fullName, tmpResource->secFileName);
-
-            }
-              break;
+    case OBJ:
+      if (param0.getType() != MT_NULL)
+        tmpResource->param[0] = param0;
+      else
+        tmpResource->param[0] = 1.0f;
+
+      if(ResourceManager::isFile(fullName))
+        tmpResource->pointer = new OBJModel(fullName, tmpResource->param[0].getFloat());
+      else
+      {
+        PRINTF(2)("File %s in %s does not exist. Loading a cube-Model instead\n", fileName, dataDir);
+        tmpResource->pointer = ResourceManager::load("cube", PRIM, prio, tmpResource->param[0].getFloat());
+      }
+      break;
+    case PRIM:
+      if (param0 != MT_NULL)
+        tmpResource->param[0] = param0;
+      else
+        tmpResource->param[0] = 1.0f;
+
+      if (!strcmp(tmpResource->name, "cube"))
+        tmpResource->pointer = new PrimitiveModel(PRIM_CUBE, tmpResource->param[0].getFloat());
+      else if (!strcmp(tmpResource->name, "sphere"))
+        tmpResource->pointer = new PrimitiveModel(PRIM_SPHERE, tmpResource->param[0].getFloat());
+      else if (!strcmp(tmpResource->name, "plane"))
+        tmpResource->pointer = new PrimitiveModel(PRIM_PLANE, tmpResource->param[0].getFloat());
+      else if (!strcmp(tmpResource->name, "cylinder"))
+        tmpResource->pointer = new PrimitiveModel(PRIM_CYLINDER, tmpResource->param[0].getFloat());
+      else if (!strcmp(tmpResource->name, "cone"))
+        tmpResource->pointer = new PrimitiveModel(PRIM_CONE, tmpResource->param[0].getFloat());
+      break;
+    case MD2:
+      if(ResourceManager::isFile(fullName))
+      {
+        tmpResource->param[0] = param0;
+        tmpResource->pointer = new MD2Data(fullName, tmpResource->param[0].getString());
+        //               tmpResource->pointer = new MD2Model(fullName, tmpResource->secFileName);
+
+      }
+      break;
 #endif /* NO_MODEL */
 #ifndef NO_TEXT
-        case TTF:
-            if (param1 != NULL)
-              tmpResource->ttfSize = *(unsigned int*)param1;
-            else
-              tmpResource->ttfSize = FONT_DEFAULT_RENDER_SIZE;
-
-          if(isFile(fullName))
-            tmpResource->pointer = new Font(fullName, tmpResource->ttfSize);
-          else
-            PRINTF(2)("%s does not exist in %s. Not loading Font\n", fileName, this->dataDir);
-          break;
+    case TTF:
+      if (param0 != MT_NULL)
+      {
+        assert(param0.getInt() >= 0);
+        tmpResource->param[0] = param0;
+      }
+      else
+        tmpResource->param[0] = FONT_DEFAULT_RENDER_SIZE;
+
+      if(isFile(fullName))
+        tmpResource->pointer = new Font(fullName, (unsigned int) tmpResource->param[0].getInt());
+      else
+        PRINTF(2)("%s does not exist in %s. Not loading Font\n", fileName, this->dataDir);
+      break;
 #endif /* NO_TEXT */
 #ifndef NO_AUDIO
-        case WAV:
-          if(isFile(fullName))
-            tmpResource->pointer = new SoundBuffer(fullName);
-          break;
-        case OGG:
-          if (isFile(fullName))
-            tmpResource->pointer = new OggPlayer(fullName);
-          break;
+    case WAV:
+      if(isFile(fullName))
+        tmpResource->pointer = new SoundBuffer(fullName);
+      break;
+    case OGG:
+      if (isFile(fullName))
+        tmpResource->pointer = new OggPlayer(fullName);
+      break;
 #endif /* NO_AUDIO */
 #ifndef NO_TEXTURES
-        case IMAGE:
-          if (param1 != NULL)
-            tmpResource->texTarget = *(GLenum*)param1;
-          else
-            tmpResource->texTarget = GL_TEXTURE_2D;
-          if(isFile(fullName))
-            {
-              PRINTF(4)("Image %s resides to %s\n", fileName, fullName);
-              tmpResource->pointer = new Texture(fullName);
-            }
-          else
-            {
-              std::list<char*>::iterator imageDir;
-              for (imageDir = this->imageDirs.begin(); imageDir != this->imageDirs.end(); imageDir++)
-                {
-                  char* imgName = new char[strlen(*imageDir)+strlen(fileName)+1];
-                  sprintf(imgName, "%s%s", *imageDir, fileName);
-                  if(isFile(imgName))
-                    {
-                      PRINTF(4)("Image %s resides to %s\n", fileName, imgName);
-                      tmpResource->pointer = new Texture(imgName, tmpResource->texTarget);
-                      delete[] imgName;
-                      break;
-                    }
-                  delete[] imgName;
-                }
-            }
-          if(!tmpResource)
-             PRINTF(2)("!!Image %s not Found!!\n", fileName);
-          break;
+    case IMAGE:
+      if (param0 != MT_NULL)
+        tmpResource->param[0] = param0;
+      else
+        tmpResource->param[0] = GL_TEXTURE_2D;
+      if(isFile(fullName))
+      {
+        PRINTF(4)("Image %s resides to %s\n", fileName, fullName);
+        tmpResource->pointer = new Texture(fullName);
+      }
+      else
+      {
+        std::vector<char*>::iterator imageDir;
+        for (imageDir = this->imageDirs.begin(); imageDir != this->imageDirs.end(); imageDir++)
+        {
+          char* imgName = new char[strlen(*imageDir)+strlen(fileName)+1];
+          sprintf(imgName, "%s%s", *imageDir, fileName);
+          if(isFile(imgName))
+          {
+            PRINTF(4)("Image %s resides to %s\n", fileName, imgName);
+            tmpResource->pointer = new Texture(imgName, tmpResource->param[0].getInt());
+            delete[] imgName;
+            break;
+          }
+          delete[] imgName;
+        }
+      }
+      if(!tmpResource)
+        PRINTF(2)("!!Image %s not Found!!\n", fileName);
+      break;
 #endif /* NO_TEXTURES */
 #ifndef NO_SHADERS
-          case SHADER:
-            if(ResourceManager::isFile(fullName))
-            {
-              if (param1 != NULL)
-              {
-                char* secFullName = ResourceManager::getFullName((const char*)param1);
-                if (ResourceManager::isFile(secFullName))
-                {
-                  tmpResource->secFileName = new char[strlen((const char*)param1)+1];
-                  strcpy(tmpResource->secFileName, (const char*) param1);
-                  tmpResource->pointer = new Shader(fullName, secFullName);
-                }
-                delete[] secFullName;
-              }
-              else
-              {
-                tmpResource->secFileName = NULL;
-                tmpResource->pointer = new Shader(fullName, NULL);
-              }
-            }
-            break;
+    case SHADER:
+      if(ResourceManager::isFile(fullName))
+      {
+        if (param0 != MT_NULL)
+        {
+          MultiType param = param0; /// HACK
+          char* secFullName = ResourceManager::getFullName(param.getString());
+          if (ResourceManager::isFile(secFullName))
+          {
+            tmpResource->param[0] = secFullName;
+            tmpResource->pointer = new Shader(fullName, secFullName);
+          }
+          delete[] secFullName;
+        }
+        else
+        {
+          tmpResource->param[0] = param0;
+          tmpResource->pointer = new Shader(fullName, NULL);
+        }
+      }
+      break;
 #endif /* NO_SHADERS */
-        default:
-          tmpResource->pointer = NULL;
-          PRINTF(1)("No type found for %s.\n   !!This should not happen unless the Type is not supported yet. JUST DO IT!!\n", tmpResource->name);
-          break;
-        }
-      if (tmpResource->pointer != NULL)
-        this->resourceList.push_back(tmpResource);
-      delete[] fullName;
-    }
+    default:
+      tmpResource->pointer = NULL;
+      PRINTF(1)("No type found for %s.\n   !!This should not happen unless the Type is not supported yet. JUST DO IT!!\n", tmpResource->name);
+      break;
+  }
   if (tmpResource->pointer != NULL)
-    return tmpResource->pointer;
-  else
-    {
-      PRINTF(2)("Resource %s could not be loaded\n", fileName);
-      delete[] tmpResource->name;
-      delete tmpResource;
-      return NULL;
-    }
-}
-
-/**
- * unloads a Resource
+    this->resourceList.push_back(tmpResource);
+  delete[] fullName;
+
+
+  if (tmpResource->pointer != NULL)
+    return tmpResource;
+  else
+  {
+    PRINTF(2)("Resource %s could not be loaded\n", fileName);
+    delete[] tmpResource->name;
+    delete tmpResource;
+    return NULL;
+  }
+}
+
+/**
+ * @brief unloads a Resource
  * @param pointer: The pointer to free
  * @param prio: the PriorityLevel to unload this resource
  * @returns true if successful (pointer found, and deleted), false otherwise
 */
-bool ResourceManager::unload(void* pointer, ResourcePriority prio)
+bool ResourceManager::unload(BaseObject* pointer, ResourcePriority prio)
 {
   if (pointer == NULL)
@@ -502,5 +577,5 @@
 
 /**
- * unloads a Resource
+ * @brief unloads a Resource
  * @param resource: The resource to unloade
  * @param prio the PriorityLevel to unload this resource
@@ -515,57 +590,57 @@
 
   if (resource->prio <= prio)
-    {
-      if (resource->count == 0)
-        {
-          // deleting the Resource
-          switch(resource->type)
-            {
+  {
+    if (resource->count == 0)
+    {
+      // deleting the Resource
+      switch(resource->type)
+      {
 #ifndef NO_MODEL
-            case OBJ:
-            case PRIM:
-              delete (Model*)resource->pointer;
-              break;
-            case MD2:
-              delete (MD2Data*)resource->pointer;
-              break;
+        case OBJ:
+        case PRIM:
+          delete (Model*)resource->pointer;
+          break;
+        case MD2:
+          delete (MD2Data*)resource->pointer;
+          break;
 #endif /* NO_MODEL */
 #ifndef NO_AUDIO
-            case WAV:
-              delete (SoundBuffer*)resource->pointer;
-              break;
-            case OGG:
-              delete (OggPlayer*)resource->pointer;
-              break;
+        case WAV:
+          delete (SoundBuffer*)resource->pointer;
+          break;
+        case OGG:
+          delete (OggPlayer*)resource->pointer;
+          break;
 #endif /* NO_AUDIO */
 #ifndef NO_TEXT
-            case TTF:
-              delete (Font*)resource->pointer;
-              break;
+        case TTF:
+          delete (Font*)resource->pointer;
+          break;
 #endif /* NO_TEXT */
 #ifndef NO_TEXTURES
-            case IMAGE:
-              delete (Texture*)resource->pointer;
-              break;
+        case IMAGE:
+          delete (Texture*)resource->pointer;
+          break;
 #endif /* NO_TEXTURES */
 #ifndef NO_SHADERS
-            case SHADER:
-              delete (Shader*)resource->pointer;
-              break;
+        case SHADER:
+          delete (Shader*)resource->pointer;
+          break;
 #endif /* NO_SHADERS */
-            default:
-              PRINTF(2)("NOT YET IMPLEMENTED !!FIX FIX!!\n");
-              return false;
-              break;
-            }
-          // deleting the List Entry:
-          PRINTF(4)("Resource %s safely removed.\n", resource->name);
-          delete[] resource->name;
-          std::list<Resource*>::iterator resourceIT = std::find(this->resourceList.begin(), this->resourceList.end(), resource);
-          this->resourceList.erase(resourceIT);
-          delete resource;
-        }
-      else
-        PRINTF(4)("Resource %s not removed, because there are still %d References to it.\n", resource->name, resource->count);
-    }
+        default:
+          PRINTF(2)("NOT YET IMPLEMENTED !!FIX FIX!!\n");
+          return false;
+          break;
+      }
+      // deleting the List Entry:
+      PRINTF(4)("Resource %s safely removed.\n", resource->name);
+      delete[] resource->name;
+      std::vector<Resource*>::iterator resourceIT = std::find(this->resourceList.begin(), this->resourceList.end(), resource);
+      this->resourceList.erase(resourceIT);
+      delete resource;
+    }
+    else
+      PRINTF(4)("Resource %s not removed, because there are still %d References to it.\n", resource->name, resource->count);
+  }
   else
     PRINTF(4)("not deleting resource %s because DeleteLevel to high\n", resource->name);
